#delimit cr
cd F:\adam\replication
capture log close
set logtype text
log using statapreplog.txt, replace
display c(current_time)

version 10.1
clear

*1 redo table 2 using PWT, report MSE by letter
* 2 redo table 2 for "D" countries
* 3 redo stat model for "D" countries, report in table of countries and a scatter
* biggest change: do not delete countries with no WDI data, they may (and do) have PWT data
* 7/10/08: this is the only change from january to july: change the source file to be the calibrated one
* 1/6/09: simplify quantile calculations using xtile
* don't merge in the long diffs before they get calculated.  While it works (just run twice), it makes things very confusing
* 5/29/09: keep some more PWT vars for local prices
* 5/30/09: moved var creation in long diffs from regression file to this creation file
* 12/31/09: add topcoding info
* 12/31/09: remove country-years affected by missing pixels
* 1/15/10 keep consumption from WDI
* 3/5/10 use v4 lights
* 3/5/10 new for v4: don't add selected WDI, just full.
* 3/5/10 new for v4: don't add Polity IV - will do if needed
* 3/5/10 new for v4: don't add WB groups - will do if needed
* 3/5/10 new for v4: don't add PWT - will do if needed
* 3/5/10 new for v4: don't add land areas - calculate in arc
* 4/6/10 add more long diff periods
* 4/20/10 add IMF data groups
* 4/22/10 include IMF data groups in long diffs
* 5/03/10 uncalibrated version
* 7/08/10 include GDP_percap_PPP in long diffs
* 8/16/10 account for gas flares separately
* 9/18/10: several changes:
*	exclude Tunisia, Puerto Rico and Saudi Arabia from the WBDQ sample
*	reflect new arc output excluding above the arctic circle
*	include missingness data so that missing country-years are selected automatically
* 	stop dropping Micronesia (FSM) - need to give it an area
*	stop dropping channel islands
*	ensure that Hong Kong and Macao are entered correctly (but then drop them anyway)
* 	remove EIA data (it only goes through 2005 anyway

* load lights data directly from arc output

odbc load, dialog(complete) dsn("dBASE Files") table("ctryout2") clear
rename ISONV10 isonv10
recast byte CONTNO
recast int isonv10 
recast long MC*
sort isonv10
save tmp4.dta, replace

odbc load, dialog(complete) dsn("dBASE Files") table("ctryoutu") clear
save global_total_dn_uncal.dta, replace
drop AREA
rename COUNTRY_1 country
rename CONTINENT continent
rename AREASQKM areasqkm
rename AREASQKM75 areasqkm75
rename ISO3V10 iso3v10
rename ISONV10 isonv10
rename COUNT75 count75
recast str3 iso3v10 
recast str8 continent
recast str52 country
recast int isonv10
recast long GFL* URWL* COUNT GFCOUNT count75 
recast byte CONTNO
sort isonv10
merge isonv10 using tmp4
tab _merge
drop _merge
erase tmp4.dta

* the country grid has two different iso3v10 codes for Jersey (JEY) and Guernsey (GGY), but the same isonv10 code (830) and the WDI reports them as one
* so I need to remove the duplicate line from here.  In inputs that only use the numeric identifier (isonv10), this isn't a problem
drop if iso3v10=="GGY"
replace iso3v10="CHI" if iso3v10=="JEY"
replace country="Channel Islands" if iso3v10=="CHI"

* fix missingness data, based on all data Below the Arctic Circle (BAC):
foreach sy in 101992 101993 101994 121994 121995 121996 121997 121998 121999 141997 141998 141999 142000 142001 142002 142003 152000 152001 152002 152003 152004 152005 152006 152007 152008 162004 162005 162006 162007 162008 {
	gen byte mf`sy' = 0
	replace mf`sy' = 1 if MAAC`sy' /  areasqkm > 0.05
	* drop MA`sy'
	* Norfolk Island (NFK), Federated States of Micronesia (FSM), Pitcairn (PCN), St. Helena (SHN), SValbard and Jan Mayen (SJM) and the Holy See (VAT) have no area info:
	replace mf`sy' = 0 if  areasqkm == 0
}

save global_total_dn_uncal.dta, replace

* note that for some systems, the appropriate call is to "Excel Files" not "XLS Files":
* load IMF data
odbc load, dsn("XLS Files;DBQ=IMF_DDS.xls") table("clean$") clear
recast str3 iso3v10 
recast str4 imftype
recast str70 country
sort iso3v10
save imf_dds, replace

* load WB DQ data
odbc load, dsn("XLS Files;DBQ=wb_dq.xls") table("export$") clear
recast str1 cat
recast str3 iso3v10 
recast str22 country
foreach i of varlist natacct-total {
	recast byte `i'
}
foreach i of varlist country-cat {
	rename `i' wbdq`i'
}
sort iso3v10
save wbdq, replace

* load dhs electricity data:
odbc load, dsn("XLS Files;DBQ=dhselect.xls") table("export$") clear
recast str3 iso3v10 
recast float fractionalyear HHpctelect_total HHpctelect_urban HHpctelect_rural, force
rename medianyear year
recast int year
gen iso3yr = iso3v10 + string(year)
sort iso3yr 
save dhs_electricity_medyr, replace

****************************
* year-hists (gini work)
****************************

* generate total count of pixels and total (unweighted) dns for each country-satyear
odbc load, dialog(complete) dsn("dBASE Files") table("ginioutu") clear
renpfix CTG totcount
gen int isonv10 = floor(VALUE/100)
gen int dn = VALUE - (isonv10 * 100)
drop VALUE
recast long totcount*
foreach i in 101992 101993 101994 121994 121995 121996 121997 121998 121999 141997 141998 141999 142000 142001 142002 142003 152000 152001 152002 152003 152004 152005 152006 152007 152008 162004 162005 162006 162007 162008 {
	gen long totdn`i' = totcount`i'*dn
}
collapse (sum) totcount101992-totcount162008 totdn101992-totdn162008, by(isonv10)
recast long tot*
sort isonv10
save tmp1.dta, replace

* generate fraction of cells unlit for each country-satyear
odbc load, dialog(complete) dsn("dBASE Files") table("ginioutu") clear
gen int isonv10 = floor(VALUE/100)
gen int dn = VALUE - (isonv10 * 100)
drop VALUE
keep if dn==0
renpfix CTG unlitcount
recast long unlitcount*
drop dn
sort isonv10
save tmp2.dta, replace

* generate number of topcoded cells for each country-satyear
odbc load, dialog(complete) dsn("dBASE Files") table("ginioutu") clear
gen int isonv10 = floor(VALUE/100)
gen int dn = VALUE - (isonv10 * 100)
keep if dn==63
drop dn isonv10
reshape long CTG, i(VALUE) j(satyear)
gen int isonv10 = floor(VALUE/100)
gen int dn = VALUE - (isonv10 * 100)
recast long CTG satyear
drop VALUE

gen long topcodeddn = CTG*dn
drop dn
rename CTG topcodedcount
reshape wide topcodedcount topcodeddn, i(isonv10) j(satyear)

* merge unweighted total dn and topcoded dn, and counts of total, unlit, and topcoded pixels into one file:
sort isonv10
merge isonv10 using tmp1.dta, _merge(_m1)
sort isonv10
merge isonv10 using tmp2.dta, _merge(_m2)
drop _m*
erase tmp1.dta
erase tmp2.dta

save tmp3, replace
egen tccount = rowtotal(topcodedcount*)
egen totalcount = rowtotal(totcount*)
collapse (sum) tccount totalcount
gen fractopcoded = tccount / totalcount
list
save result_topcoding, replace

use tmp3, clear
erase tmp3.dta
reshape long totcount10 totcount12 totcount14 totcount15 totcount16 totdn10 totdn12 totdn14 totdn15 totdn16 topcodedcount10 topcodedcount12 topcodedcount14 topcodedcount15 topcodedcount16 topcodeddn10 topcodeddn12 topcodeddn14 topcodeddn15 topcodeddn16 unlitcount10 unlitcount12 unlitcount14 unlitcount15 unlitcount16, i(isonv10) j(year)
gen long isonv10yr = isonv10*10000 + year
sort isonv10yr
foreach i in totcount totdn topcodedcount topcodeddn unlitcount {
	egen `i' = rowmean(`i'10 `i'12 `i'14 `i'15 `i'16)
	drop `i'10 `i'12 `i'14 `i'15 `i'16
}
drop isonv10 year
recast long totcount
save countspanel_uncal.dta, replace

********************
* back to main data
********************

use global_total_dn_uncal.dta, clear

* cross-sectional merges:
sort iso3v10
merge iso3v10 using imf_dds.dta, unique _merge(_mimfgroup) keep(Date_DSBB imftype)
sort iso3v10
merge iso3v10 using wbdq, nokeep uniqusing _merge(_mwbdq)
recast str3 iso3v10 

sort isonv10
* note, this was produced using the separate file v4ginicalc_uncal.do:
merge isonv10 using ginistata_uncal.dta, unique nokeep _merge(_mgini)
recast int isonv10

* rename the uncalibrated variables to be the same as the calibrated ones, so I don't have to change the regression commands:
renpfix URWL RAWL
renpfix ULAR LAR
renpfix ULSD LSD

reshape long LAR10 LAR12 LAR14 LAR15 LAR16 ALT10 ALT12 ALT14 ALT15 ALT16 LSD10 LSD12 LSD14 LSD15 LSD16 RAWL10 RAWL12 RAWL14 RAWL15 RAWL16 lgini10 lgini12 lgini14 lgini15 lgini16 GFL10 GFL12 GFL14 GFL15 GFL16 GULA10 GULA12 GULA14 GULA15 GULA16 MAAC10 MAAC12 MAAC14 MAAC15 MAAC16 MA7510 MA7512 MA7514 MA7515 MA7516 MC7510 MC7512 MC7514 MC7515 MC7516 mf10 mf12 mf14 mf15 mf16, i(isonv10) j(year)

gen long isonv10yr = isonv10*10000 + year
sort isonv10yr
foreach i in lgini LAR LSD ALT RAWL GFL GULA MAAC MA75 MC75 {
	egen `i' = rowmean(`i'10 `i'12 `i'14 `i'15 `i'16)
	drop `i'10 `i'12 `i'14 `i'15 `i'16
}
foreach i in mf {
	egen int `i' = rowmax(`i'10 `i'12 `i'14 `i'15 `i'16)
	drop `i'10 `i'12 `i'14 `i'15 `i'16
}
foreach v of var LAR LSD ALT RAWL GFL GULA MAAC MA75 MC75 { 
	rename `v' `=lower("`v'")' 
} 
rename mf missingpercent_over5

* panel merges:
gen iso3v10yr = iso3v10 + string(year)
sort iso3v10yr
merge iso3v10yr using wdi_limited, _merge(_mwdidata)
tab _mwdidata
* this should only include country aggregates, and Montenegro, which we want to drop anyway (if not, something is wrong): 
tab name if _mwdidata==2
drop name
drop if _mwdidata==2

gen iso3yr = iso3v10 + string(year)
sort iso3yr 
merge iso3yr using dhs_electricity_medyr
tab _merge
drop _merge iso3yr fractionalyear medianisfirst

sort isonv10yr
merge isonv10yr using countspanel_uncal.dta, _merge(_mcounts)
erase countspanel_uncal.dta
tab _mcounts
drop if _mcounts==2

* account for the fact that FSM is missing from gluareag (note that PCN, SHN, SJM, VAT, NFK are too, but they have no WDI data (or any other data)
* the 0.5 is pretty arbitrary - wouldn't want to use this estimate without FEs:
replace lar = rawl * 0.5 if iso3v10=="FSM"
* the 675 is from GPW: 
replace areasqkm = 675 if iso3v10=="FSM"

**************************
* generate new variables:
**************************

gen fraccellstopcoded =  topcodedcount/ totcount
gen fracdntopcoded =  topcodeddn/ totdn
gen fracunlit =  unlitcount/ totcount

gen lntopcodedcount = ln(topcodedcount+1)
gen lnunlitcount = ln(unlitcount+1)

gen lnareasqkm = ln(areasqkm)
gen lnkwh_use = ln(EGUSEELECKH)
gen lnpop = ln(SPPOPTOTL)

gen avdn = lar/areasqkm
gen pctlit = alt / areasqkm
gen lndn = ln(avdn)
gen lndnnogf = ln((lar - gula) / areasqkm)
* the relevant comparison is dn*sqkm versus dn*sqkm (i.e. lar vs gula):
gen fracgf = gula/lar

gen lnlsd = ln(lsd)

* for quadratics
gen lndnsq = lndn * lndn

* for interactions:
gen lndnlgini = lndn * lgini
gen lginisq = lgini * lgini

gen  lngdpwdilocal = ln(NYGDPPCAPKN* SPPOPTOTL)
rename NYGDPPCAPPPKD GDP_percap_PPP

gen byte imftypenum = 1 if imftype=="SDDS"
replace imftypenum = 2 if imftype=="GDDS"

save global_total_dn_uncal.dta, replace

****************
* misc. stats: *
****************

collapse (sum) maac areasqkm ma75 areasqkm75 mc75 count75
gen fracmiss =  maac / areasqkm
gen fracmissarea75 =  ma75 / areasqkm75
gen fracmisscells75 =  mc75 / count75
save results_missing, replace
list

use global_total_dn_uncal.dta, clear
keep if continent=="Africa"
* drop North Africa
drop if iso3v10=="DZA" | iso3v10=="MAR" | iso3v10=="EGY" | iso3v10=="TUN" | iso3v10=="LBY"
* drop islands
drop if iso3v10=="COM" | iso3v10=="CPV" | iso3v10=="SYC" | iso3v10=="STP" | iso3v10=="SHN" | iso3v10=="REU" | iso3v10=="MUS" | iso3v10=="MYT"
* drop GNQ and ZAF:
drop if iso3v10=="GNQ" | iso3v10=="ZAF" 
keep if year==2000
collapse (sum)  GFAREASQKM GFGLP00AG GLOBPOP GLOBARE totcount 
gen gfpopfrac =  GFGLP00AG /  GLOBPOP
gen gfareafrac =   GFAREASQKM /  GLOBARE
gen satyearpixels = totcount * 30
gen region = "Africa"
drop G*
sort region
save results_gf_arctic1, replace

use global_total_dn_uncal.dta, clear
keep if continent=="Africa"
* drop North Africa
drop if iso3v10=="DZA" | iso3v10=="MAR" | iso3v10=="EGY" | iso3v10=="TUN" | iso3v10=="LBY"
* drop islands
drop if iso3v10=="COM" | iso3v10=="CPV" | iso3v10=="SYC" | iso3v10=="STP" | iso3v10=="SHN" | iso3v10=="REU" | iso3v10=="MUS" | iso3v10=="MYT"
* drop GNQ and ZAF:
drop if iso3v10=="GNQ" | iso3v10=="ZAF" 
gen NGA_gfl = 0
replace NGA_gfl = gfl if iso3v10=="NGA"
collapse (sum) gula  lar gfl NGA_gfl
gen gflightfrac = gula / lar
gen NGAfrac = NGA_gfl / gfl 
gen region = "Africa"
keep NGAfrac gflightfrac region
sort region
merge region using results_gf_arctic1
drop _merge
save results_gf_arctic1, replace

use global_total_dn_uncal.dta, clear
keep if year==2000
collapse (sum)  GFAREASQKM GFGLP00AG GLOBPOP GLOBARE ARCTPOPAC ARCTAREAC ARCTPOP75 ARCTARE75 totcount
gen gfpopfrac =  GFGLP00AG /  GLOBPOP
gen gfareafrac =   GFAREASQKM /  GLOBARE
gen arctpopfrac =  ARCTPOPAC /  GLOBPOP
gen arctareafrac =   ARCTAREAC /  GLOBARE
gen arct75popfrac =  ARCTPOP75 /  GLOBPOP
gen arct75areafrac =   ARCTARE75 /  GLOBARE
gen satyearpixels = totcount * 30
gen region = "Global"
drop G* A*
sort region
save results_gf_arctic, replace

use global_total_dn_uncal.dta, clear
collapse (sum) gula  lar
gen gflightfrac = gula / lar
drop gula lar
gen region = "Global"
sort region
merge region using results_gf_arctic
drop _merge
append using results_gf_arctic1
erase results_gf_arctic1.dta
save results_gf_arctic, replace

list

use global_total_dn_uncal.dta, clear
gen gflightfrac = gula / lar
list year gflightfrac if iso3v10=="GNQ"
outsheet year gflightfrac if iso3v10=="GNQ" using results_gnq_gflightfrac.csv, comma replace

***********
* deletes *
***********

use global_total_dn_uncal.dta, clear

* list and remove country-years affected by missing pixels (more than 5% of area)
table iso3v10 if missingpercent_over5==1 & ~missing(lngdpwdilocal), row replace
save results_missingcountries, replace

use global_total_dn_uncal.dta, clear
drop if  missingpercent_over5==1

* remove Serbia/Montenegro/Kosovo because of changing borders over the time period:
drop if iso3v10=="SCG" | iso3v10=="MNE" | iso3v10=="KSV"

* remove Hong Kong and Macao
drop if iso3v10=="HKG" | iso3v10=="MAC"

**********************
* variable labelling *
**********************

recast str52 COUNTRY_1
recast str8 CONTINENT

label variable isonv10 "ISO numerical country code"
label variable iso3v10 "ISO 3-letter country code"
label variable CONTNO "Continent"
label variable COUNT "number of grid cells south of the Arctic Circle"
label variable areasqkm "permanent ice-free land area south of the Arctic Circle (square km)"
label variable areasqkm75 "permanent ice-free land area south of 75 degrees north latitude (square km)"
label variable count75 "number of grid cells south of 75 degrees north latitude"
label variable GFCOUNT "cells in gas flare polygons"
label variable GFAREASQKM "permanent ice-free land area in gas flare polygons (square km)"
label variable GFGLP00AG "Population (year 2000) in gas flare polygons"
label variable GLOBARE "permanent ice-free land area, all latitudes"
label variable GLOBPOP "Population (year 2000)"
label variable ARCTAREAC "permanent ice-free land area north of the Arctic Circle"
label variable ARCTPOPAC "Population (year 2000) north of the Arctic Circle"
label variable ARCTARE75 "permanent ice-free land area north of 75 degrees north latitude"
label variable ARCTPOP75 "Population (year 2000) north of 75 degrees north latitude"
label variable ISO3V10 "ISO 3-letter country code"
label variable Date_DSBB "IMF: Date Metadata First Posted on the DSBB"
label variable imftype "IMF Group"
label variable _mimfgroup "In any IMF group?"
label variable wbdqcountry "World Bank (2002): Country"
label variable wbdqnatacct "World Bank (2002): National accounts base year is 1991 or later"
label variable wbdqbop "World Bank (2002): Uses Balance of Payments manual 5"
label variable wbdqexdebt "World Bank (2002): External Debt is actual not preliminary"
label variable wbdqeximprice "World Bank (2002): Import Export Prices"
label variable wbdqpopcensus "World Bank (2002): Population census 1991 or later"
label variable wbdqvrsys "World Bank (2002): Vital registration system present"
label variable wbdqagcensus "World Bank (2002): Agricultural census 1991 or later"
label variable wbdqCPI "World Bank (2002): CPI base year is 1991 or later"
label variable wbdqprodindex "World Bank (2002): Production index"
label variable wbdqSDDS "World Bank (2002): SDDS"
label variable wbdqtotal "World Bank (2002): total data quality score"
label variable wbdqcat "World Bank (2002): total data quality score category"
label variable _mwbdq "World Bank (2002) data exist"
label variable _mgini "Data exist for gini calculation"
label variable isonv10yr "Numeric unique Identifier"
label variable lgini "gini of lights digital number (DN)"
label variable lar "total of (lights digital number (DN) * cell land area)"
label variable lsd "Standard deviation of lights digital number"
label variable alt "Area lit (square kilometers)"
label variable rawl "total lights digital number (DN), unweighted"
label variable gfl "total lights digital number (DN) in gas flare polygons, unweighted"
label variable gula "total of (lights digital number (DN) * cell land area) in gas flare polygons"
label variable maac "Land area (square km) with missing lights data south of the Arctic Circle"
label variable ma75 "Land area (square km) with missing lights data south of 75 degrees N latitude"
label variable mc75 "Cells with missing lights data south of 75 degrees north latitude"
label variable missingpercent_over5 "More than 5% of land area below then Arctic Circle is missing data"
label variable iso3v10yr "Alphanumeric unique Identifier"
label variable _mwdidata "WDI data exist"
label variable HHpctelect_total "DHS: fraction of households with electricity"
label variable HHpctelect_urban "DHS: fraction of urban households with electricity"
label variable HHpctelect_rural "DHS: fraction of rural households with electricity"
label variable totcount "number of grid cells south of the Arctic Circle"
label variable totdn "total lights digital number (DN), unweighted"
label variable topcodedcount "number of cells topcoded"
label variable topcodeddn "total lights digital number (DN) in topcoded cells"
label variable unlitcount "number of cells unlit"
label variable _mcounts "light counts data exist"
label variable fraccellstopcoded "fraction of cells topcoded"
label variable fracdntopcoded "fraction of lights digital number (DN) topcoded"
label variable fracunlit "fraction of cells unlit"
label variable lntopcodedcount "ln(number of cells topcoded)"
label variable lnunlitcount "ln(number of cells unlit)"
label variable lnareasqkm "ln(permanent ice-free land area south of the Arctic Circle (square km))"
label variable lnkwh_use "ln(Electric power consumption (kWh))"
label variable lnpop "ln(Population)"
label variable avdn "area-weighted average lights digital number (DN) per cell"
label variable pctlit "fraction of land area lit"
label variable lndn "ln(area-weighted average lights digital number (DN) per cell)"
label variable lndnnogf "ln(area-weighted avg lights digital number (DN) per cell, w/o gas flare lights)"
label variable fracgf "fraction of lights digital number (DN) deriving from gas flare polygons"
label variable lnlsd "ln(Standard deviation of lights digital number)"
label variable lndnsq "ln(area-weighted average lights digital number (DN) per cell), squared"
label variable lndnlgini "ln(area-weighted average lights digital number (DN) per cell) * gini"
label variable lginisq "gini of lights digital number (DN), squared"
label variable lngdpwdilocal "ln(GDP, constant local currency units)"
label variable imftypenum "IMF Group, numeric"

save global_total_dn_uncal.dta, replace

**********************************
* generate long difference files *
**********************************

use global_total_dn_uncal.dta, clear
keep if year==1992 | year==1993 | year==2005 | year==2006
keep country year isonv10 iso3v10 imftype imftypenum wbdqtotal lndn lndnnogf lngdpwdilocal totcount totdn topcodedcount topcodeddn unlitcount lnkwh_use fracdntopcoded fraccellstopcoded fracunlit lntopcodedcount lnunlitcount GDP_percap_PPP
reshape wide                                                   lndn lndnnogf lngdpwdilocal totcount totdn topcodedcount topcodeddn unlitcount lnkwh_use fracdntopcoded fraccellstopcoded fracunlit lntopcodedcount lnunlitcount GDP_percap_PPP, i(isonv10) j(year)
foreach i in                                                   lndn lndnnogf lngdpwdilocal totcount totdn topcodedcount topcodeddn unlitcount lnkwh_use fracdntopcoded fraccellstopcoded fracunlit lntopcodedcount lnunlitcount GDP_percap_PPP {
	egen `i'9293 = rowmean( `i'1992 `i'1993)
	egen `i'0506 = rowmean( `i'2005 `i'2006)
	gen `i'longdiff = `i'0506 - `i'9293
}
label variable fraccellstopcoded9293 "fraction of cells topcoded, 1992-93"
label variable fracdntopcoded9293 "fraction of lights digital number (DN) topcoded, 1992-93"
label variable fracunlit9293 "fraction of cells unlit, 1992-93"
label variable lndn9293 "ln(area-weighted average lights digital number (DN) per cell), 1992-93"
label variable lndnnogf9293 "ln(area-weighted avg lights DN per cell, w/o gas flare lights), 1992-93"
label variable lngdpwdilocal9293 "ln(GDP, constant local currency units), 1992-93"
label variable lnkwh_use9293 "ln(Electric power consumption (kWh)), 1992-93"
label variable lntopcodedcount9293 "ln(number of cells topcoded), 1992-93"
label variable lnunlitcount9293 "ln(number of cells unlit), 1992-93"
label variable topcodedcount9293 "number of cells topcoded, 1992-93"
label variable topcodeddn9293 "total lights digital number (DN) in topcoded cells, 1992-93"
label variable totcount9293 "number of grid cells south of the Arctic Circle, 1992-93"
label variable totdn9293 "total lights digital number (DN), unweighted, 1992-93"
label variable unlitcount9293 "number of cells unlit, 1992-93"
label variable GDP_percap_PPP9293 "GDP per capita, PPP (constant 2005 international $), 1992-93"

label variable fraccellstopcoded0506 "fraction of cells topcoded, 2005-06"
label variable fracdntopcoded0506 "fraction of lights digital number (DN) topcoded, 2005-06"
label variable fracunlit0506 "fraction of cells unlit, 2005-06"
label variable lndn0506 "ln(area-weighted average lights digital number (DN) per cell), 2005-06"
label variable lndnnogf0506 "ln(area-weighted avg lights DN per cell, w/o gas flare lights), 2005-06"
label variable lngdpwdilocal0506 "ln(GDP, constant local currency units), 2005-06"
label variable lnkwh_use0506 "ln(Electric power consumption (kWh)), 2005-06"
label variable lntopcodedcount0506 "ln(number of cells topcoded), 2005-06"
label variable lnunlitcount0506 "ln(number of cells unlit), 2005-06"
label variable topcodedcount0506 "number of cells topcoded, 2005-06"
label variable topcodeddn0506 "total lights digital number (DN) in topcoded cells, 2005-06"
label variable totcount0506 "number of grid cells south of the Arctic Circle, 2005-06"
label variable totdn0506 "total lights digital number (DN), unweighted, 2005-06"
label variable unlitcount0506 "number of cells unlit, 2005-06"
label variable GDP_percap_PPP0506 "GDP per capita, PPP (constant 2005 international $), 2005-06"

label variable fraccellstopcodedlongdiff "fraction of cells topcoded, long difference"
label variable fracdntopcodedlongdiff "fraction of lights digital number (DN) topcoded, long difference"
label variable fracunlitlongdiff "fraction of cells unlit, long difference"
label variable lndnlongdiff "ln(area-weighted average lights digital number (DN) per cell), long difference"
label variable lndnnogflongdiff "ln(area-weighted avg lights DN per cell, w/o gas flare lights), long difference"
label variable lngdpwdilocallongdiff "ln(GDP, constant local currency units), long difference"
label variable lnkwh_uselongdiff "ln(Electric power consumption (kWh)), long difference"
label variable lntopcodedcountlongdiff "ln(number of cells topcoded), long difference"
label variable lnunlitcountlongdiff "ln(number of cells unlit), long difference"
label variable topcodedcountlongdiff "number of cells topcoded, long difference"
label variable topcodeddnlongdiff "total lights digital number (DN) in topcoded cells, long difference"
label variable totcountlongdiff "number of grid cells south of the Arctic Circle, long difference"
label variable totdnlongdiff "total lights digital number (DN), unweighted, long difference"
label variable unlitcountlongdiff "number of cells unlit, long difference"
label variable GDP_percap_PPPlongdiff "GDP per capita, PPP (constant 2005 international $), long difference"

drop *1992 *1993 *2005 *2006
save global_total_dn_uncal_longdiff9206.dta, replace

use global_total_dn_uncal.dta, clear
keep if year==1992 | year==1993 | year==2007 | year==2008
keep country year isonv10 iso3v10 imftype imftypenum wbdqtotal lndn lndnnogf lngdpwdilocal totcount totdn topcodedcount topcodeddn unlitcount lnkwh_use fracdntopcoded fraccellstopcoded fracunlit lntopcodedcount lnunlitcount GDP_percap_PPP
reshape wide                                                   lndn lndnnogf lngdpwdilocal totcount totdn topcodedcount topcodeddn unlitcount lnkwh_use fracdntopcoded fraccellstopcoded fracunlit lntopcodedcount lnunlitcount GDP_percap_PPP, i(isonv10) j(year)
foreach i in                                                   lndn lndnnogf lngdpwdilocal totcount totdn topcodedcount topcodeddn unlitcount lnkwh_use fracdntopcoded fraccellstopcoded fracunlit lntopcodedcount lnunlitcount GDP_percap_PPP {
	egen `i'9293 = rowmean( `i'1992 `i'1993)
	egen `i'0708 = rowmean( `i'2007 `i'2008)
	gen `i'longdiff = `i'0708 - `i'9293
}
label variable fraccellstopcoded9293 "fraction of cells topcoded, 1992-93"
label variable fracdntopcoded9293 "fraction of lights digital number (DN) topcoded, 1992-93"
label variable fracunlit9293 "fraction of cells unlit, 1992-93"
label variable lndn9293 "ln(area-weighted average lights digital number (DN) per cell), 1992-93"
label variable lndnnogf9293 "ln(area-weighted avg lights DN per cell, w/o gas flare lights), 1992-93"
label variable lngdpwdilocal9293 "ln(GDP, constant local currency units), 1992-93"
label variable lnkwh_use9293 "ln(Electric power consumption (kWh)), 1992-93"
label variable lntopcodedcount9293 "ln(number of cells topcoded), 1992-93"
label variable lnunlitcount9293 "ln(number of cells unlit), 1992-93"
label variable topcodedcount9293 "number of cells topcoded, 1992-93"
label variable topcodeddn9293 "total lights digital number (DN) in topcoded cells, 1992-93"
label variable totcount9293 "number of grid cells south of the Arctic Circle, 1992-93"
label variable totdn9293 "total lights digital number (DN), unweighted, 1992-93"
label variable unlitcount9293 "number of cells unlit, 1992-93"
label variable GDP_percap_PPP9293 "GDP per capita, PPP (constant 2005 international $), 1992-93"

label variable fraccellstopcoded0708 "fraction of cells topcoded, 2007-08"
label variable fracdntopcoded0708 "fraction of lights digital number (DN) topcoded, 2007-08"
label variable fracunlit0708 "fraction of cells unlit, 2007-08"
label variable lndn0708 "ln(area-weighted average lights digital number (DN) per cell), 2007-08"
label variable lndnnogf0708 "ln(area-weighted avg lights DN per cell, w/o gas flare lights), 2007-08"
label variable lngdpwdilocal0708 "ln(GDP, constant local currency units), 2007-08"
label variable lnkwh_use0708 "ln(Electric power consumption (kWh)), 2007-08"
label variable lntopcodedcount0708 "ln(number of cells topcoded), 2007-08"
label variable lnunlitcount0708 "ln(number of cells unlit), 2007-08"
label variable topcodedcount0708 "number of cells topcoded, 2007-08"
label variable topcodeddn0708 "total lights digital number (DN) in topcoded cells, 2007-08"
label variable totcount0708 "number of grid cells south of the Arctic Circle, 2007-08"
label variable totdn0708 "total lights digital number (DN), unweighted, 2007-08"
label variable unlitcount0708 "number of cells unlit, 2007-08"
label variable GDP_percap_PPP0708 "GDP per capita, PPP (constant 2005 international $), 2007-08"

label variable fraccellstopcodedlongdiff "fraction of cells topcoded, long difference"
label variable fracdntopcodedlongdiff "fraction of lights digital number (DN) topcoded, long difference"
label variable fracunlitlongdiff "fraction of cells unlit, long difference"
label variable lndnlongdiff "ln(area-weighted average lights digital number (DN) per cell), long difference"
label variable lndnnogflongdiff "ln(area-weighted avg lights DN per cell, w/o gas flare lights), long difference"
label variable lngdpwdilocallongdiff "ln(GDP, constant local currency units), long difference"
label variable lnkwh_uselongdiff "ln(Electric power consumption (kWh)), long difference"
label variable lntopcodedcountlongdiff "ln(number of cells topcoded), long difference"
label variable lnunlitcountlongdiff "ln(number of cells unlit), long difference"
label variable topcodedcountlongdiff "number of cells topcoded, long difference"
label variable topcodeddnlongdiff "total lights digital number (DN) in topcoded cells, long difference"
label variable totcountlongdiff "number of grid cells south of the Arctic Circle, long difference"
label variable totdnlongdiff "total lights digital number (DN), unweighted, long difference"
label variable unlitcountlongdiff "number of cells unlit, long difference"
label variable GDP_percap_PPPlongdiff "GDP per capita, PPP (constant 2005 international $), long difference"

drop *1992 *1993 *2007 *2008
save global_total_dn_uncal_longdiff9208.dta, replace

display c(current_time)
log close
exit, clear
